
#include "ofPlayingCard.h"

ofPlayingCard::ofPlayingCard(){

	width = 60;
	height = 80;
	x = 0;
	y = 0;
	rotation = 0;
	alpha = 255;
	suit = 0;
	num = ofRandom(0, 13);
	setCardNumber(num);
	
	lastTime = ofGetElapsedTimeMillis();
	duration = 0;
	
	selected = false;
	
	franklinBook.loadFont("frabk.ttf", 15);
}

ofPlayingCard::ofPlayingCard(int x_, int y_){

	
	width = 60;
	height = 80;
	rotation = 0;
	alpha = 255;
	suit = 0;
	num = ofRandom(0, 13);
	setCardNumber(num);
	
	lastTime = ofGetElapsedTimeMillis();
	duration = 0;
	
	selected = false;
	
	franklinBook.loadFont("frabk.ttf", 15);
	
	x = x_;
	y = y_;
	
}

void ofPlayingCard::draw(){

	int currentTime = ofGetElapsedTimeMillis();
	duration += currentTime - lastTime;
	lastTime = currentTime;
		
	
	ofSetRectMode(OF_RECTMODE_CENTER);

	glPushMatrix();
	
		// white card
	
		ofSetColor(255, 255, 255, alpha);
	
		glTranslatef(x, y, 0);
		
		glRotatef(rotation, 0, 0, 1);
		
		ofRect(0, 0, width, height);
		
		// red lettering
		
		ofSetColor(255, 0, 0, alpha);
		
		glTranslatef(-width/2, -height/2, 0);
		
		franklinBook.drawString(cardNumAsString, 3, 15);
		
		glTranslatef(0, 20, 0);
		
		franklinBook.drawString(ofToString(suit), 3, 15);
	
	glPopMatrix();
}

void ofPlayingCard::setCardNumber(int i){

	string cards[] = { "A", "2", "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q", "K" };

	num = i+1;

	cardNumAsString = cards[i];
}

void ofPlayingCard::setCardSuit(int i){

	//string cards[] = { "A", "2", "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q", "K" };

	suit = i;
}

bool ofPlayingCard::ifCornerClicked(int mouseX, int mouseY){

	//printf("%i\n", mouseX - x - 40);
	//printf("%i\n", mouseY - y);
	
	bool corner = false;
	
	int distX = mouseX - x - 40;
	int distY = mouseY - y;

	//if(distX < 20 && distX > 0) printf("clicked");
	
	if(distY < 20 && distY > 0 && distX < 20 && distX > 0) corner = true;
	
	return corner;
}


bool ofPlayingCard::ifCardClicked(int mouseX, int mouseY){
	
	bool card = false;
	
	int distX = mouseX - x;
	int distY = mouseY - y;

	//printf("dist %i %i\n", distX, distY);
	
	if(distY > -height/2 && distY < height/2 && distX < width/2 && distX > -width/2) card = true;
	
	return card;
}