#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	 

	ofBackground(0,0,0);
	ofSetFrameRate(30);
	ofEnableAlphaBlending();
	
	deckState = 0;
	
	rotateCard = false;
	
	
}

//--------------------------------------------------------------
void testApp::update(){

	
}

//--------------------------------------------------------------
void testApp::draw(){

	int maxDuration = 4000;

	
	for(int i=cards.size()-1; i>=0; i--){
	
		cards[i]->draw();
		
		if(cards[i]->duration < maxDuration){
		
			cards[i]->alpha = 255 - (float(cards[i]->duration)/maxDuration * 255);
			synthesizer.voice[i]->volume = 1.0-(float(cards[i]->duration)/maxDuration);
		
		} else {
		
			synthesizer.voice[i]->volume = 0;
			cards.erase(cards.begin()+i);
			synthesizer.voice.erase(synthesizer.voice.begin()+i);
		}
	}
	
	ofSetColor(255, 255, 255);
	
	ofDrawBitmapString(ofToString(rotateCard), 20, 20);

}


//--------------------------------------------------------------
void testApp::placeNewCard(int x, int y){

	ofPlayingCard * newCard = new ofPlayingCard(x, y);

	cards.push_back(newCard);
	
	ofSynthVoice * newVoice = new ofSynthVoice();
	
	synthesizer.voice.push_back(newVoice);
	synthesizer.voice[cards.size()-1]->setFreq(y*10+400);
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	//printf("key %i\n", key);
	
	int keyArray[] = { 96, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 45, 61 };
	int keyMatch = 99;
	
	int suitArray[] = { 113, 119, 101, 114 };
	int suitMatch = 99;
	
	if(deckState == 1){
	
		for(int i=0; i<13; i++){
		
			if(keyArray[i] == key){
			
				//printf("match %i\n", i);
				cards[cardSelected]->setCardNumber(i);
			}
		}
		
		for(int i=0; i<4; i++){
		
			if(suitArray[i] == key){
			
				//printf("match %i\n", i);
				cards[cardSelected]->setCardSuit(i);
			}
		}
	}
	
	if(key == 122){
	
		rotateCard = !rotateCard;
	
	} 
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){ 
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
	if(deckState == 1){
	
		if(rotateCard){
		
			int cardX = cards[cardSelected]->x;
			
			cards[cardSelected]->rotation = -1 * (cardX - x);
			
			
		
		} else {
		
			cards[cardSelected]->x = x;
			cards[cardSelected]->y = y;
			
			synthesizer.voice[cardSelected]->setFreq(y*10+400);
		
		}
	}

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

	bool ifClicked = false; //myCard.ifCardClicked(x, y);
	//int cardClicked = 0;
	
	for(int i=0; i<cards.size(); i++){
	
		bool test = cards[i]->ifCardClicked(x, y);
		
		if(test) { cardSelected = i; ifClicked = true; }
	}
	
	//printf("test %i\n", ifClicked);
	
	if(ifClicked) {
	
		deckState = 1;
		
	} else {
	
		deckState = 0;
		placeNewCard(x, y);
		
		deckState = 1;
		
		cardSelected = cards.size()-1;
	}
	
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

	deckState = 0;
	//myCard.selected = false;
}
