#ifndef _OF_PLAYING_CARD
#define _OF_PLAYING_CARD


#include "ofMain.h"


class ofPlayingCard {
	
	public:
	
		// making and breaking
		ofPlayingCard(int x_, int y_, int num_, int suit_);
		~ofPlayingCard();
		
		// card functions
		void draw();
		bool ifCornerClicked(int mouseX, int mouseY);
		bool ifCardClicked(int mouseX, int mouseY);
		void setCardNumber(int i);
		void setCardSuit(int i);
		
		// audio functions
		void play();
		void stop();
		void loadSound(string fileName, bool ifLoop);
		
		// appearance
		int alpha;
		int width, height;
		int x, y;
		int rotation;
		
		// card info
		int suit;  // 0=hearts 1=clubs 2=diamonds 3=spades
		int num;
		string cardNumAsString;
		
		// when user drags
		bool selected;
		
		// duration to play sound for
		int noteDuration;
		
		// the active font
		ofTrueTypeFont franklinBook;
		
		// for tracking duration of the card (not used right now)
		int duration;
		int lastTime;
		
		// sound player
		ofSoundPlayer snd;
		bool isLooping;
		bool active;

};

#endif	

