/*
 *  ofSynthVoice.cpp
 *  openFrameworks
 *
 *  Created by cinema on 4/30/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "ofSynthVoice.h"

ofSynthVoice::ofSynthVoice(){

	sampleRate 			= 44100;
	phase 				= 0;
	phaseAdder 			= 0.0f;
	phaseAdderTarget 	= 0.0f;
	volume				= 0.0f;
	
	bufferSize = 256;
	
	targetFrequency = 200.0f;
	phaseAdderTarget = (targetFrequency / (float) sampleRate) * TWO_PI;
	
	buffer = new float[bufferSize];
}

void ofSynthVoice::setFreq(float f){

	targetFrequency = f;
	phaseAdderTarget = (targetFrequency / (float) sampleRate) * TWO_PI;
}


void ofSynthVoice::update(){

	while (phase > TWO_PI){
		phase -= TWO_PI;
	}
	
	phaseAdder = 0.95f * phaseAdder + 0.05f * phaseAdderTarget;
	
	for (int i = 0; i < bufferSize; i++){
	
		phase += phaseAdder;
		float sample = sin(phase);
	
		buffer[i] = sample * volume;

	}
}
